[Setup]
;-- Main Setup Information
 AppName                         = Fortitude HTTP
 AppVerName                      = Fortitude HTTP 1.0.1.7
 AppCopyright                    = Copyright  1995-2010 NetworkDLS.
 DefaultDirName                  = {pf}\NetworkDLS\Fortitude HTTP
 DefaultGroupName                = NetworkDLS\Fortitude HTTP
 UninstallDisplayIcon            = {app}\HTTPSvr.Exe
 WizardImageFile                 = /../../@Setup Resources/LgSetup.bmp
 WizardSmallImageFile            = /../../@Setup Resources/SmSetup.bmp
 PrivilegesRequired              = PowerUser
 Uninstallable                   = Yes
 AppMutex                        = Fortitude HTTP
 LicenseFile                     = /../../@Setup Resources/EULA.txt
 Compression                     = ZIP/9
 OutputBaseFilename              = HTTPServer64
 MinVersion                      = 0.0,5.0
 ArchitecturesInstallIn64BitMode = x64
 ArchitecturesAllowed            = x64

;-- Windows 2000 & XP (Support Dialog)
 AppPublisher    = NetworkDLS
 AppPublisherURL = http://www.NetworkDLS.com/
 AppUpdatesURL   = http://www.NetworkDLS.com/
 AppVersion      = 1.0.1.7

[Tasks]
 Name: InstallService;              Description: "Install as service"; GroupDescription: "System Service:";
 Name: InstallService\StartService; Description: "Start the service";  GroupDescription: "System Service:";

[Components]
 Name: Base;                        Description: "Base Install";                  Flags: Fixed;     Types: full compact custom;
 Name: Base\IndexImages;            Description: "Index Images";                  Flags: Fixed;     Types: full compact custom;
 Name: Base\CustomErrors;           Description: "Custom Errors";                 Flags: Fixed;     Types: full compact custom;
 Name: Base\AutoUpdate;             Description: "AutoUpdate Utility";                              Types: full compact custom;
 Name: Configuration;               Description: "Configuration Files";           Flags: Fixed;     Types: full compact custom;
 Name: Configuration\PreConfigured; Description: "Configured with Examples";      Flags: exclusive; Types: full;
 Name: Configuration\nonConfigured; Description: "Minimal pre-Configuration";     Flags: exclusive; Types: compact;

[Files]
 Source: "..\..\@AutoUpdate\x64\AutoUpdate.Exe";    DestDir: "{app}\Bin";                       Components: Base\AutoUpdate; Flags: RestartReplace;
 Source: "AutoUpdate.xml";                          DestDir: "{app}\Bin";                       Components: Base\AutoUpdate; Flags: IgnoreVersion;
 Source: "..\Release\x64\HTTPSvr.Exe";              DestDir: "{app}\Bin";                       Components: Base; Flags: IgnoreVersion;
 Source: "..\..\@Setup Resources\EULA.txt";         DestDir: "{app}";                           Components: Base;
 Source: "Resources\Start.ico";                     DestDir: "{app}";                           Components: Base;
 Source: "Resources\Stop.ico";                      DestDir: "{app}";                           Components: Base;
 Source: "Messages\*.*";                            DestDir: "{app}\Messages";                  Components: Base\CustomErrors;            Flags: RecurseSubDirs OnlyIfDoesntExist;
 Source: "Filters\*.*";                             DestDir: "{app}\Filters";                   Components: Configuration\PreConfigured;  Flags: RecurseSubDirs OnlyIfDoesntExist;
 Source: "IndexImages\*.*";                         DestDir: "{app}\IndexImages";               Components: Base\IndexImages;             Flags: RecurseSubDirs OnlyIfDoesntExist;

 Source: "Data\*.*";                                DestDir: "{sd}\Fortitude HTTP\Data";        Components: Configuration;                Flags: OnlyIfDoesntExist;
 Source: "Data\preConfigured\*.*";                  DestDir: "{sd}\Fortitude HTTP\Data";        Components: Configuration\PreConfigured;  Flags: OnlyIfDoesntExist;
 Source: "Data\nonConfigured\*.*";                  DestDir: "{sd}\Fortitude HTTP\Data";        Components: Configuration\nonConfigured;  Flags: OnlyIfDoesntExist;
 Source: "WebSites\*.*";                            DestDir: "{sd}\Fortitude HTTP\WebSites";    Components: Configuration\PreConfigured;  Flags: RecurseSubDirs OnlyIfDoesntExist;

[Dirs]
 Name: "{sd}\Fortitude HTTP\Logs"
 Name: "{sd}\Fortitude HTTP\Cache"

[Icons]
 Name: "{group}\Web Root";                 Filename: "{sd}\Fortitude HTTP\WebSites"; WorkingDir: "{sd}\Fortitude HTTP\WebSites"; Parameters: "/Stop";                                                  Components: Configuration\PreConfigured;
 Name: "{group}\Management Console";       Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/OpenManager";    IconFilename: "{app}\Bin\HTTPSvr.exe"; Tasks: InstallService;
 Name: "{group}\Management Console";       Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/NonService";     IconFilename: "{app}\Bin\HTTPSvr.exe"; Tasks: NOT InstallService;
 Name: "{group}\Start Service";            Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/Start";          IconFilename: "{app}\Start.ico";       Tasks: InstallService;
 Name: "{group}\Stop Service";             Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/Stop";           IconFilename: "{app}\Stop.ico";        Tasks: InstallService;
 Name: "{group}\Advanced\Flush Settings";  Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/FlushSettings";  IconFilename: "{app}\Bin\HTTPSvr.exe"; Tasks: InstallService;
 Name: "{group}\Advanced\Reload Sites";    Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/ReloadSites";    IconFilename: "{app}\Bin\HTTPSvr.exe"; Tasks: InstallService;
 Name: "{group}\Advanced\Reload Settings"; Filename: "{app}\Bin\HTTPSvr.Exe";        WorkingDir: "{app}\Bin";                    Parameters: "/ReloadSettings"; IconFilename: "{app}\Bin\HTTPSvr.exe"; Tasks: InstallService;
 Name: "{group}\AutoUpdate";               Filename: "{app}\Bin\AutoUpdate.Exe";     WorkingDir: "{app}\Bin";                    Components: Base\AutoUpdate;
 Name: "{group}\Uninstall";                Filename: "{uninstallexe}";

[Registry]
 Root: HKLM; Subkey: "Software\NetworkDLS\Fortitude HTTP"; Flags: uninsdeletekey noerror;
 Root: HKLM; Subkey: "Software\NetworkDLS\Fortitude HTTP"; ValueName: "DataPath";       ValueType: String; ValueData: "{sd}\Fortitude HTTP\Data"; Flags: CreateValueIfDoesntExist;
 Root: HKLM; Subkey: "Software\NetworkDLS\Fortitude HTTP"; ValueName: "Path";           ValueType: String; ValueData: "{app}";                    Flags: CreateValueIfDoesntExist;

[UninstallDelete]
 Type: FilesAndOrDirs; Name: "{sd}\Fortitude HTTP\Logs"
 Type: FilesAndOrDirs; Name: "{sd}\Fortitude HTTP\Cache"

[Run]
 Filename: "{app}\Bin\HTTPSvr.Exe"; Parameters: "/Install"; Tasks: InstallService;
 Filename: "{app}\Bin\HTTPSvr.Exe"; Parameters: "/Start";   Tasks: InstallService\StartService;
 Filename: "{app}\Bin\HTTPSvr.Exe"; Parameters: "/NonService";  Description: "Open Management Console"; Flags: postinstall nowait skipifsilent runasoriginaluser; Tasks: NOT InstallService;
 Filename: "{app}\Bin\HTTPSvr.Exe"; Parameters: "/OpenManager"; Description: "Open Management Console"; Flags: postinstall nowait skipifsilent runasoriginaluser; Tasks: InstallService\StartService;

[UninstallRun]
 Filename: "{app}\Bin\HTTPSvr.Exe"; Parameters: "/Stop";   RunOnceId: "StopService";   MinVersion: 0, 4.0; Tasks: InstallService;
 Filename: "{app}\Bin\HTTPSvr.Exe"; Parameters: "/Delete"; RunOnceId: "DeleteService"; MinVersion: 0, 4.0; Tasks: InstallService;
 
