///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CAuthentication_H
#define _CAuthentication_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CXML/CXMLWriter.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define AUTHENTICATION_LIST_POS_PAGE		0
#define AUTHENTICATION_LIST_POS_DESCR		1

#define AUTHENTICATION_MAX_PAGE_LENGTH	MAX_PATH
#define AUTHENTICATION_MAX_DESCR_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Protected_Page{
	char *Page;
	int PageLength;
	char *Description;
	bool Enabled;
} PROTECTEDPAGE, *LPPROTECTEDPAGE;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Protected_Pages{
	int Count;
	PROTECTEDPAGE *Items;
	bool Enabled;
} PROTECTEDPAGES, *LPPROTECTEDPAGES;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CAuthentication{

private:
	bool Initialized;
	void *pWebSites;
	PROTECTEDPAGES Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CAuthentication(void);
	CAuthentication(void *lpWebSites);
	CAuthentication(void *lpWebSites, CXMLReader *xmlConfig, CAuthentication *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, PROTECTEDPAGE *pPage);
	void AddConfigItem(HWND hListView, PROTECTEDPAGE *pPage, int iInsertionIndex);

	void PopInfoList(HWND hListView);
	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);

	bool IsAuthorizationRequired(VOID *pClient);
	bool IsAuthenticated(VOID *pClient);
	bool Authenticate(VOID *pClient);

	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CAuthentication *pDefaults);

	bool Reload(void);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);

	bool Destroy();
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
