///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CCGIFolders_H
#define _CCGIFolders_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define CGIFOLDERS_LIST_POS_PATH		0
#define CGIFOLDER_LIST_POS_DESCR	1

#define CGIFOLDER_MAX_PATH_LENGTH	MAX_PATH
#define CGIFOLDER_MAX_DESCR_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_CGI_Folder{
	char *Path; //relative to root (e.g. /cgi-bin)
	int Length;
	bool Enabled;
	char *Description;
} CGIFOLDER, *LPCGIFOLDER;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_CGI_Folders{
	int Count;
	CGIFOLDER *Items;
	bool Enabled;
} CGIFOLDERS, *LPCGIFOLDERS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CCGIFolders{

private:
	bool Initialized;
	void *pWebSites;
	CGIFOLDERS Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CCGIFolders(void);
	CCGIFolders(void *lpWebSites);
	CCGIFolders(void *lpWebSites, CXMLReader *xmlConfig, CCGIFolders *pDefaults);
	bool Save(void);
	
	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);
	void PopInfoList(HWND hListView);

	void AddConfigItem(HWND hListView, CGIFOLDER *pFolder);
	void AddConfigItem(HWND hListView, CGIFOLDER *pFolder, int iInsertionIndex);

	bool IsInCGIFolder(VOID *pClient);
	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CCGIFolders *pDefaults);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);
	bool Reload(void);
	bool Destroy(void);
	bool Enabled(void);
	bool ToXML(CXMLReader *lpXML);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
