///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CDefaultPages_H
#define _CDefaultPages_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CXML/CXMLWriter.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define DEFAULTPAGES_LIST_POS_PAGE		0
#define DEFAULTPAGES_LIST_POS_DESCR		1

#define DEFAULTPAGES_MAX_PAGE_LENGTH	MAX_PATH
#define DEFAULTPAGES_MAX_DESCR_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Default_Page{
	char *Page;
	int PageLength;
	char *Description;
	bool Enabled;
} DEFAULTPAGE, *LPDEFAULTPAGE;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Default_Pages{
	int Count;
	DEFAULTPAGE *Items;
	bool Enabled;
} DEFAULTPAGES, *LPDEFAULTPAGES;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CDefaultPages{

private:
	bool Initialized;
	void *pWebSites;
	DEFAULTPAGES Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CDefaultPages(void);
	CDefaultPages(void *lpWebSites);
	CDefaultPages(void *lpWebSites, CXMLReader *xmlConfig, CDefaultPages *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, DEFAULTPAGE *pPage);
	void AddConfigItem(HWND hListView, DEFAULTPAGE *pPage, int iInsertionIndex);

	void PopInfoList(HWND hListView);
	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);

	bool CheckPath(char *&sFullRequest);

	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CDefaultPages *pDefaults);

	bool Reload(void);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);

	bool Destroy();
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
