///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CDirectoryIndexing_H
#define _CDirectoryIndexing_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CStack/CStack.H"
#include "CWebSites.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Indexed_Object {
	char *Name;
	__int64 Size;
	FILETIME LastModified;
} INDEXEDOBJECT, *LPINDEXEDOBJECT;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Indexed_Objects {
	INDEXEDOBJECT *Object;
	int Count;
} INDEXEDOBJECTS, *LPINDEXEDOBJECTS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Directory_Index {
	INDEXEDOBJECTS Files;
	INDEXEDOBJECTS Folders;
} DIRECTORYINDEX, *LPDIRECTORYINDEX;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CDirectoryIndexing {

private:
	DIRECTORYINDEX Index;

public:
	bool IndexDirectory(const char *sDirectory);
	bool Destroy(void);
	bool ToHTML(const char *sCurrentFolder, CStringBuilder *lpStr);
	bool SendContents(CLIENT *pC, const char *sDirectory);
	bool GetFileIcon(const char *sFileNameAndPath, char *sIconURL, int iMaxIconURL);

};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif