///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CErrorPages_H
#define _CErrorPages_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define ERRORPAGES_LIST_POS_CODE		0
#define ERRORPAGES_LIST_POS_DESCR		1
#define ERRORPAGES_LIST_POS_FILE		2

#define ERRORPAGES_MAX_CODE_LENGTH	10
#define ERRORPAGES_MAX_FILE_LENGTH	MAX_PATH
#define ERRORPAGES_MAX_DESCR_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_ErrorPage{
	char *Code;
	char *File;
	char *Description;
	bool Enabled;
} ERRORPAGE, *LPERRORPAGE;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_ErrorPages{
	int Count;
	ERRORPAGE *Items;
	char DefaultFile[MAX_PATH];
} ERRORPAGES, *LPERRORPAGES;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CErrorPages{

private:
	bool Initialized;
	void *pWebSites;
	ERRORPAGES Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

	DWORD dwErrorCount;
	DWORD dwWarningCount;

public:
	CErrorPages(void *lpWebSites);
	~CErrorPages(void);
	CErrorPages(void *lpWebSites, CXMLReader *xmlConfig, CErrorPages *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, ERRORPAGE *pPage);
	void AddConfigItem(HWND hListView, ERRORPAGE *pPage, int iInsertionIndex);

	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iDefaultFile);
	void PopInfoList(HWND hListView);

	bool LoadNewConfiguration(HWND hWnd, HWND hGrid, HWND hDefaultFile);
	bool Reload(void);
	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CErrorPages *pDefaults);
	bool Destroy();

	DWORD WarningCount(void);
	DWORD ErrorCount(void);

	bool AuthorizationRequired(VOID *pClient);

	bool SendError(VOID *pClient, const char *sErrorCode);
	bool SendError(VOID *pClient, const char *sErrorCode, const char *sDetails);
	bool SendAdvancedError(VOID *pClient, const char *sErrCode, const char *sErrDesc,
		const char *sDetails, const char *sErrorPage, const char *sExtraHeaders);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
