///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _CExtensionFilters_H
#define _CExtensionFilters_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define EXTENSIONFILTERS_LIST_POS_EXT	0
#define EXTENSIONFILTER_LIST_POS_DESCR	1

#define EXTFILTERS_MAX_EXT_LENGTH		MAX_PATH
#define EXTFILTERS_MAX_DESCR_LENGTH		1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Extension_Filter{
	char *Extension;
	int ExtensionLength;
	char *Description;
	bool Enabled;
} EXTENSIONFILTER, *LPEXTENSIONFILTER;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Extension_Filters{
	int Count;
	EXTENSIONFILTER *Items;
	bool Enabled;
} EXTENSIONFILTERS, *LPEXTENSIONFILTERS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CExtensionFilters{

private:
	bool Initialized;
	void *pWebSites;
	EXTENSIONFILTERS Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CExtensionFilters(void);
	CExtensionFilters(void *lpWebSites);
	CExtensionFilters(void *lpWebSites, CXMLReader *xmlConfig, CExtensionFilters *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, EXTENSIONFILTER *pFilter, int iInsertionIndex);
	void AddConfigItem(HWND hListView, EXTENSIONFILTER *pFilter);

	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);
	void PopInfoList(HWND hListView);

	bool CheckFile(const char *sString);
	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CExtensionFilters *pDefaults);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);
	bool Reload(void);

	bool Destroy(void);
	bool Enabled(void);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
