///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CHTTP_H
#define _CHTTP_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "CWebSite.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CHTTP{

private:
	VOID *pWebSites;

public:
	CHTTP(VOID *lpWebSites);
	~CHTTP(void);

	int GetHTTPHeaderTag(const char *sHeader, const int iHeaderLen, const char *sTag, char *&sBuf);
	int GetHTTPHeaderTag(const char *sHeader, const int iHeaderLen, const char *sTag, char *sBuf, int iMaxBuf);
	bool DoesHeaderContainTag(const char *sBuf, const int iBufLen, const char *sTag);
	bool DoesHeaderContainTag(const char *sBuf, const int iBufLen, const char *sTag, int *iHeaderEndPos);
	bool IsValueEqual(const char *sValue1, const char *sValue2);
	bool DoesValueContain(const char *sIn, const char *sValue);
	bool SendRawFileEx(CLIENT *pC, const char *sFileName, char *sBuffer, unsigned int iBufferSz);
	bool SendFileWithHeader(CLIENT *pC, const char *sFileName);
	bool SendRawFile(CLIENT *pC, const char *sFileName);
	bool SendHTTPHeader(CLIENT *pC, const char *sErrCode, const char *sErrDesc,
		const char *sEncoding, const char *sMimeType, __int64 i64ContentLength,
		const char *sExtraHeaders, bool bTerminateHeader);
	bool SendOKHeader(CLIENT *pC, __int64 i64FileSize);
	bool SendOKHeader(CLIENT *pC, const char *sMimeType, const char *sEncoding, __int64 i64FileSize);
	bool SendOKHeader(CLIENT *pC, const char *sMimeType, const char *sEncoding, __int64 i64FileSize, bool bTerminateHeader);
	bool SendOKHeader(CLIENT *pC, const char *sMimeType, __int64 i64FileSize);
	bool BufferDataToClient(CLIENT *pC, const char *sData, unsigned int iDataLength);
	bool BufferDataToClient(CLIENT *pC, CStringBuilder *sData);
	bool SendOKHeader(CLIENT *pC, const char *sFileName);
	bool SendOKHeader(CLIENT *pC, const char *sFileName, const char *sEncoding);
	bool FreeClientHeader(CLIENT *pC);
	bool ParseHTTPHeader(CWebSite *pWebSite, CLIENT *pC, const char *sBuf, const int iBufLen);
	bool GetHeaderRequestRange(CWebSite *pWebSite, CLIENT *pC, const char *sBuf, const int iBufLen);
	bool AssembleFullRequest(CWebSite *pWebSite, CLIENT *pC);
	bool ProcessRequest(CWebSite *pWebSite, CLIENT *pC, const char *sHeader, const int iHeaderLength);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

