///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CIPFilters_H
#define _CIPFilters_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define IPFILTERS_LIST_POS_IP		0
#define IPFILTERS_LIST_POS_DESCR	1

#define IPFILTERS_MAX_IP_LENGTH		16
#define IPFILTERS_MAX_DESCR_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_IP_Filter{
	char *IP;
	char *Description;
	bool Enabled;
} IPFILTER, *LPIPFILTER;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_IP_Filters{
	int Count;
	IPFILTER *Items;
	bool Enabled;
} IPFILTERS, *LPIPFILTERS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CIPFilters{

private:
	bool Initialized;
	void *pWebSites;
	IPFILTERS Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CIPFilters(void);
	CIPFilters(void *lpWebSites);
	CIPFilters(void *lpWebSites, CXMLReader *xmlConfig, CIPFilters *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, IPFILTER *pIP);
	void AddConfigItem(HWND hListView, IPFILTER *pIP, int iInsertionIndex);

	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);
	void PopInfoList(HWND hListView);

	bool IsIPAllowed(const char *sIP);
	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CIPFilters *pDefaults);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);
	bool Reload(void);
	bool Destroy(void);
	bool Enabled(void);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
