///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CMIMETYPES_H
#define _CMIMETYPES_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define MIMETYPES_LIST_POS_EXTENSION	0
#define MIMETYPES_LIST_POS_TYPE			1
#define MIMETYPES_LIST_POS_DESCR		2

#define MIMETYPES_MAX_TYPE_LENGTH		255
#define MIMETYPES_MAX_EXT_LENGTH		MAX_PATH
#define MIMETYPES_MAX_DESCR_LENGTH		1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Mime_Type{
	char *Extension;
	char *Type;
	char *Description;
	bool Enabled;
} MIMETYPE, *LPMIMETYPE;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Mime_Types{
	int Count;
	MIMETYPE *Items;
	bool Enabled;
} MIMETYPES, *LPMIMETYPES;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CMimeTypes{

private:
	bool Initialized;
	void *pWebSites;
	MIMETYPES Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CMimeTypes(void);
	CMimeTypes(void *lpWebSites);
	CMimeTypes(void *lpWebSites, CXMLReader *xmlConfig, CMimeTypes *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, MIMETYPE *pType);
	void AddConfigItem(HWND hListView, MIMETYPE *pType, int iInsertionIndex);

	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);
	void PopInfoList(HWND hListView);

	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CMimeTypes *pDefaults);
	bool Destroy();
	bool GetType(const char *sFileName, char *sMimeName, int iMaxMimeName);
	bool Reload(void);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);
	bool Export(const char *sFileName);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
