///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CRealms_H
#define _CRealms_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CXML/CXMLWriter.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define REALM_LIST_POS_PAGE		0
#define REALM_LIST_POS_DESCR		1

#define REALM_MAX_PAGE_LENGTH	MAX_PATH
#define REALM_MAX_DESCR_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Realm{
	char *Page;
	int PageLength;
	char *Description;
	bool Enabled;
} REALM, *LPREALM;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Realms{
	int Count;
	REALM *Items;
	bool Enabled;
} REALMS, *LPREALMS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CRealms{

private:
	bool Initialized;
	void *pWebSites;
	REALMS Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	~CRealms(void);
	CRealms(void *lpWebSites);
	CRealms(void *lpWebSites, CXMLReader *xmlConfig, CRealms *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, REALM *pRealm);
	void AddConfigItem(HWND hListView, REALM *pRealm, int iInsertionIndex);

	void PopInfoList(HWND hListView);
	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);

	bool CheckPath(char *&sFullRequest);

	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CRealms *pDefaults);

	bool Reload(void);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);

	bool Destroy();
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
