///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CURLFilters_H
#define _CURLFilters_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define URLFILTERS_LIST_POS_SEQ			0
#define URLFILTERS_LIST_POS_SCANREQUEST	1
#define URLFILTERS_LIST_POS_SCANQUERY	2
#define URLFILTERS_LIST_POS_DESCR		3

#define URLFILTERS_MAX_SEQ_LENGTH		255
#define URLFILTERS_MAX_DESCR_LENGTH		1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_URL_Filter{
	char *Sequence;
	int SequenceLength;
	bool ScanRequest;
	bool ScanQuery;
	char *Description;
	bool Enabled;
} URLFILTER, *LPURLFILTER;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_URL_Filters{
	int Count;
	URLFILTER *Items;
	bool Enabled;
} URLFILTERS, *LPURLFILTERS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CURLFilters{

private:
	bool Initialized;
	void *pWebSites;
	URLFILTERS Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	CURLFilters(void *lpWebSites);
	~CURLFilters(void);
	CURLFilters(void *lpWebSites, CXMLReader *xmlConfig, CURLFilters *pDefaults);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, URLFILTER *pFilter);
	void AddConfigItem(HWND hListView, URLFILTER *pFilter, int iInsertionIndex);

	void PopInfoList(HWND hListView);
	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);

	bool ScanHeader(VOID *pHeader);
	bool Reload(void);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);
	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CURLFilters *pDefaults);
	bool Destroy(void);
	bool Enabled(void);
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
