///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CVirtualRoots_H
#define _CVirtualRoots_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../../@Classes/CXML/CXMLReader.H"
#include "../../@Classes/CStringBuilder/CStringBuilder.H"
#include "../../@Classes/CLocks/CLocks.H"
#include "../../@Classes/CStack/CStack.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define VIRTUALROOTS_LIST_POS_ROOT		0
#define VIRTUALROOTS_LIST_POS_PATH		1
#define VIRTUALROOTS_LIST_POS_DESCR		2
#define VIRTUALROOTS_LIST_POS_USER		3
#define VIRTUALROOTS_LIST_POS_DOMAIN	4
#define VIRTUALROOTS_LIST_POS_PASS		5

#define VIRTUALROOTS_MAX_ROOT_LENGTH	MAX_PATH
#define VIRTUALROOTS_MAX_PATH_LENGTH	MAX_PATH
#define VIRTUALROOTS_MAX_DESCR_LENGTH	1024
#define VIRTUALROOTS_MAX_USER_LENGTH	1024
#define VIRTUALROOTS_MAX_DOMAIN_LENGTH	1024
#define VIRTUALROOTS_MAX_PASS_LENGTH	1024

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Root{
	char *Root;
	char *Path;
	int PathLength;
	int RootLength;
	char *Description;
	bool Enabled;

	char *Username;
	char *Domain;
	char *Password;
} ROOT, *LPROOT;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_Roots{
	int Count;
	ROOT *Items;
	bool Enabled;
} ROOTS, *LPROOTS;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CVirtualRoots{

private:
	bool Initialized;
	void *pWebSites;
	ROOTS Collection;
	char sFileName[MAX_PATH];

	CLocks Locks;

public:
	CVirtualRoots(void *lpWebSites);
	CVirtualRoots(void *lpWebSites, CXMLReader *xmlConfig, CVirtualRoots *pDefaults);
	~CVirtualRoots(void);
	bool Save(void);

	bool ToXML(CXMLReader *lpXML);

	void AddConfigItem(HWND hListView, ROOT *pRoot);
	void AddConfigItem(HWND hListView, ROOT *pRoot, int iInsertionIndex);

	void PopInfoList(HWND hListView, bool bUseIcons);
	void PopConfigList(HWND hWnd, int iListView, int iEnabled);
	void PopInfoList(HWND hListView);

	ROOT *IsVirtualRoot(const char *sRequest, char *&sFullRequest);
	bool LoadNewConfiguration(HWND hWnd, HWND hGrid);
	bool Reload(void);
	bool Load(const char *sXMLFileName);
	bool Load(CXMLReader *xmlConfig, CVirtualRoots *pDefaults);
	bool Destroy();
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
