///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _CWEBSITE_CPP
#define _CWEBSITE_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <StdLib.H>
#include <Share.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Entry.H"
#include "CWebSite.H"
#include "CWebSites.H"
#include "CHTTP.H"
#include "CWebSites.H"
#include "SocketHandlers.H"
#include "ConfigTree.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

using namespace NSWFL::Conversion;
using namespace NSWFL::ListView;
using namespace NSWFL::DateTime;
using namespace NSWFL::File;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern HIMAGELIST hEnableDisableImageList; //Declared in MainDialog.cpp
extern HIMAGELIST hOnePixilImageList; //Declared in MainDialog.cpp

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::AddConfigItem(HWND hListView, const char *sAttribute, const char *sValue)
{
	LV_ITEM LVItem;
    memset(&LVItem, 0, sizeof(LVItem));

	int iIndex = ListView_GetItemCount(hListView);

    LVItem.pszText = (char *) sAttribute;
    LVItem.mask = LVIF_TEXT;
    LVItem.iSubItem = WEBSITES_LIST_POS_ATTRIB;
	LVItem.iItem = iIndex;
    ListView_InsertItem(hListView, &LVItem);

    LVItem.pszText = (char *) sValue;
    LVItem.mask = LVIF_TEXT;
    LVItem.iSubItem = WEBSITES_LIST_POS_VALUE;
	LVItem.iItem = iIndex;
    ListView_SetItem(hListView, &LVItem);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::AddConfigItem(HWND hListView, const char *sAttribute, bool bValue)
{
	if(bValue)
	{
		this->AddConfigItem(hListView, sAttribute, "Yes");
	}
	else{
		this->AddConfigItem(hListView, sAttribute, "No");
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::AddConfigItem(HWND hListView, const char *sAttribute, double dValue)
{
	char sValue[64];
	sprintf_s(sValue, sizeof(sValue), "%f", dValue);
	this->AddConfigItem(hListView, sAttribute, sValue);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::AddConfigItem(HWND hListView, const char *sAttribute, int iValue)
{
	char sValue[64];
	sprintf_s(sValue, sizeof(sValue), "%d", iValue);
	this->AddConfigItem(hListView, sAttribute, sValue);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::AddConfigItem(HWND hListView, const char *sAttribute, unsigned int iValue)
{
	char sValue[64];
	sprintf_s(sValue, sizeof(sValue), "%d", iValue);
	this->AddConfigItem(hListView, sAttribute, sValue);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
	Returns the index of this WebSite in the parent collection.
*/
int CWebSite::Index(void)
{
	for(int iIndex = 0; iIndex < ((CWebSites *)pWebSites)->Collection.Count; iIndex++)
	{
		if(this == ((CWebSites *)pWebSites)->Collection.WebSite[iIndex])
		{
			return iIndex;
		}
	}
	return -1;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::AddConfigItem(HWND hListView)
{
	LV_ITEM LVItem;
    memset(&LVItem, 0, sizeof(LVItem));

	char sInt[64];

	int iIndex = ListView_GetItemCount(hListView);

	int iImage = this->pServer->IsActive();

    LVItem.pszText = (char *) this->Name;
    LVItem.mask = LVIF_TEXT|LVIF_IMAGE;
	LVItem.iImage = iImage;
    LVItem.iSubItem = WEBSITES_LIST_POS_NAME;
	LVItem.iItem = iIndex;
    ListView_InsertItem(hListView, &LVItem);

    LVItem.pszText = (char *) FormatInteger(sInt, sizeof(sInt), this->Port);
    LVItem.mask = LVIF_TEXT;
    LVItem.iSubItem = WEBSITES_LIST_POS_PORT;
	LVItem.iItem = iIndex;
    ListView_SetItem(hListView, &LVItem);

    LVItem.pszText = (char *) this->Description;
    LVItem.mask = LVIF_TEXT;
    LVItem.iSubItem = WEBSITES_LIST_POS_DESCR;
	LVItem.iItem = iIndex;
    ListView_SetItem(hListView, &LVItem);

    LVItem.pszText = (char *) this->Root;
    LVItem.mask = LVIF_TEXT;
    LVItem.iSubItem = WEBSITES_LIST_POS_ROOT;
	LVItem.iItem = iIndex;
    ListView_SetItem(hListView, &LVItem);

	sprintf_s(sInt, sizeof(sInt), "%d", this->Index());
    LVItem.pszText = (char *) sInt;
    LVItem.mask = LVIF_TEXT;
    LVItem.iSubItem = WEBSITES_LIST_POS_INDEX;
	LVItem.iItem = iIndex;
    ListView_SetItem(hListView, &LVItem);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::PopInfoList(HWND hListView)
{
	SendMessage(hListView, (UINT)WM_SETREDRAW , (WPARAM)FALSE, (LPARAM)0);

	LV_COLUMN MyLVColumn;
    memset(&MyLVColumn, 0, sizeof(LV_COLUMN));

	MyLVColumn.cx        = 100;
    MyLVColumn.pszText   = "Attribute";
    MyLVColumn.iSubItem  = WEBSITES_LIST_POS_ATTRIB;
    MyLVColumn.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
    MyLVColumn.fmt       = LVCFMT_LEFT;
    ListView_InsertColumn(hListView, WEBSITES_LIST_POS_ATTRIB, &MyLVColumn);

	MyLVColumn.cx        = 500;
    MyLVColumn.pszText   = "Value";
    MyLVColumn.iSubItem  = WEBSITES_LIST_POS_VALUE;
    MyLVColumn.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM | LVCF_FMT;
    MyLVColumn.fmt       = LVCFMT_LEFT;
    ListView_InsertColumn(hListView, WEBSITES_LIST_POS_VALUE, &MyLVColumn);

	SendMessage(hListView, (UINT)LVM_SETEXTENDEDLISTVIEWSTYLE, (WPARAM)0,
		(LPARAM)LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_HEADERDRAGDROP);

	ListView_SetImageList(hListView, hOnePixilImageList, LVSIL_SMALL);

	ListView_SetTextColor(hListView, RGB(0,0,100));

	//Pop the list-view.

	this->AddConfigItem(hListView, "Name", this->Name);
	this->AddConfigItem(hListView, "Description", this->Description);
	this->AddConfigItem(hListView, "Root", this->Root);
	this->AddConfigItem(hListView, "Port", this->Port);

	LVAutoSizeColumns(hListView, 500);
	SendMessage(hListView, (UINT)WM_SETREDRAW , (WPARAM)TRUE, (LPARAM)0);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CWebSite::CWebSite()
{
	this->hLogFile = NULL;
	memset(this->sLogCycleDate, 0, sizeof(this->sLogCycleDate));
	memset(&this->csLogFile, 0, sizeof(this->csLogFile));
	this->Clients = NULL;

	memset(&this->Stats, 0, sizeof(this->Stats));
	this->pWebSites = NULL;
	this->pHttp = NULL;
	this->pServer = NULL;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CWebSite::CWebSite(void *lpWebSites, CXMLReader *pXMLSite)
{
	this->pWebSites = lpWebSites;

	this->hLogFile = NULL;
	memset(this->sLogCycleDate, 0, sizeof(this->sLogCycleDate));
	memset(&this->csLogFile, 0, sizeof(this->csLogFile));
	this->Clients = NULL;

	memset(&this->Stats, 0, sizeof(this->Stats));
	this->pHttp = NULL;
	this->pServer = NULL;

	CXMLReader xmlConfig;

	InitializeCriticalSection(&this->csLogFile);

	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("Settings", &xmlConfig))
	{
		this->pSettings = new CSettings(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltSettings);
		xmlConfig.Destroy();
	}
	else{
		this->pSettings = ((CWebSites *)pWebSites)->DfltSettings;
	}
	//----------------------------------------------------------------------

	pXMLSite->ToString("Name", this->Name, sizeof(this->Name));
	pXMLSite->ToString("Description", this->Description, sizeof(this->Description));
	pXMLSite->ToString("Root", this->Root, sizeof(this->Root));
	this->Port = pXMLSite->ToInteger("Port", 80);

	this->pServer = new CSocketServer;
	this->Clients = (CLIENT *) pMem->Allocate(sizeof(CLIENT), this->pSettings->MaxConnections());


	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("CGIFolders", &xmlConfig))
	{
		this->pCGIFolders = new CCGIFolders(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltCGIFolders);
		xmlConfig.Destroy();
	}
	else{
		this->pCGIFolders = ((CWebSites *)pWebSites)->DfltCGIFolders;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("Compression", &xmlConfig))
	{
		this->pCompression = new CCompression(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltCompression);
		xmlConfig.Destroy();
	}
	else{
		this->pCompression = ((CWebSites *)pWebSites)->DfltCompression;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("CustomFilters", &xmlConfig))
	{
		this->pCustomFilters = new CCustomFilters(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltCustomFilters);
		xmlConfig.Destroy();
	}
	else{
		this->pCustomFilters = ((CWebSites *)pWebSites)->DfltCustomFilters;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("DefaultPages", &xmlConfig))
	{
		this->pDefaultPages = new CDefaultPages(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltDefaultPages);
		xmlConfig.Destroy();
	}
	else{
		this->pDefaultPages = ((CWebSites *)pWebSites)->DfltDefaultPages;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("ExtensionFilters", &xmlConfig))
	{
		this->pExtensionFilters = new CExtensionFilters(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltExtensionFilters);
		xmlConfig.Destroy();
	}
	else{
		this->pExtensionFilters = ((CWebSites *)pWebSites)->DfltExtensionFilters;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("IPFilters", &xmlConfig))
	{
		this->pIPFilters = new CIPFilters(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltIPFilters);
		xmlConfig.Destroy();
	}
	else{
		this->pIPFilters = ((CWebSites *)pWebSites)->DfltIPFilters;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("MimeTypes", &xmlConfig))
	{
		this->pMimeTypes = new CMimeTypes(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltMimeTypes);
		xmlConfig.Destroy();
	}
	else{
		this->pMimeTypes = ((CWebSites *)pWebSites)->DfltMimeTypes;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("ScriptingEngines", &xmlConfig))
	{
		this->pScriptingEngines = new CScriptingEngines(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltScriptingEngines);
		xmlConfig.Destroy();
	}
	else{
		this->pScriptingEngines = ((CWebSites *)pWebSites)->DfltScriptingEngines;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("Realms", &xmlConfig))
	{
		this->pRealms = new CRealms(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltRealms);
		xmlConfig.Destroy();
	}
	else{
		this->pRealms = ((CWebSites *)pWebSites)->DfltRealms;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("Authentication", &xmlConfig))
	{
		this->pAuthentication = new CAuthentication(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltAuthentication);
		xmlConfig.Destroy();
	}
	else{
		this->pAuthentication = ((CWebSites *)pWebSites)->DfltAuthentication;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("SSIFiles", &xmlConfig))
	{
		this->pSSIFiles = new CSSIFiles(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltSSIFiles);
		xmlConfig.Destroy();
	}
	else{
		this->pSSIFiles = ((CWebSites *)pWebSites)->DfltSSIFiles;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("URLFilters", &xmlConfig))
	{
		this->pURLFilters = new CURLFilters(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltURLFilters);
		xmlConfig.Destroy();
	}
	else{
		this->pURLFilters = ((CWebSites *)pWebSites)->DfltURLFilters;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("VirtualRoots", &xmlConfig))
	{
		this->pVirtualRoots = new CVirtualRoots(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltVirtualRoots);
		xmlConfig.Destroy();
	}
	else{
		this->pVirtualRoots = ((CWebSites *)pWebSites)->DfltVirtualRoots;
	}
	//----------------------------------------------------------------------
	if(pXMLSite->ToReader("ErrorPages", &xmlConfig))
	{
		this->pErrorPages = new CErrorPages(this->pWebSites, &xmlConfig, ((CWebSites *)pWebSites)->DfltErrorPages);
		xmlConfig.Destroy();
	}
	else{
		this->pErrorPages = ((CWebSites *)pWebSites)->DfltErrorPages;
	}
	//----------------------------------------------------------------------

	if(this->pServer->Initialize(this->Port,
		this->pSettings->MaxConnections(),
		Socket_ClientHandler, Socket_ErrorHandler))
	{
		this->pServer->PacketMode(false);
		this->pServer->SetOnSend(Socket_SendHandler);
		this->pServer->SetOnRecv(Socket_RecvHandler);
		this->pServer->SetOnAccept(Socket_AcceptHandler);
		this->pServer->SetOnDisconnect(Socket_DisconnectHandler);

		this->pServer->pUserData = pMem->Allocate(sizeof(SERVERTHREADINFO), 1);

		SERVERTHREADINFO STI;
		STI.iSiteIndex = ((CWebSites *)pWebSites)->Collection.Count;
		STI.pWebSites = ((CWebSites *)pWebSites);

		memcpy(this->pServer->pUserData, &STI, sizeof(SERVERTHREADINFO));

		if(this->CycleLog())
		{
			if(this->pSettings->AutoStart())
			{
				this->pServer->Start();
			}
		}
	}
	else{
		((CWebSites*)this->pWebSites)->Trace("The website's server failed to initialize.");
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

CWebSite::~CWebSite()
{
	CWebSites *pWebSites = ((CWebSites *)this->pWebSites);
	if(pWebSites)
	{
		this->Stop();

		if(this->pCGIFolders && this->pCGIFolders != pWebSites->DfltCGIFolders)
			delete this->pCGIFolders;
		if(this->pCompression && this->pCompression != pWebSites->DfltCompression)
			delete this->pCompression;        
		if(this->pCustomFilters && this->pCustomFilters != pWebSites->DfltCustomFilters) 
			delete this->pCustomFilters;      
		if(this->pDefaultPages && this->pDefaultPages != pWebSites->DfltDefaultPages)
			delete this->pDefaultPages;       
		if(this->pExtensionFilters && this->pExtensionFilters != pWebSites->DfltExtensionFilters)
			delete this->pExtensionFilters;   
		if(this->pIPFilters && this->pIPFilters != pWebSites->DfltIPFilters)
			delete this->pIPFilters;          
		if(this->pMimeTypes && this->pMimeTypes != pWebSites->DfltMimeTypes)
			delete this->pMimeTypes;          
		if(this->pScriptingEngines && this->pScriptingEngines != pWebSites->DfltScriptingEngines)
			delete this->pScriptingEngines;   
		if(this->pRealms && this->pRealms != pWebSites->DfltRealms)
			delete this->pRealms;   
		if(this->pAuthentication && this->pAuthentication != pWebSites->DfltAuthentication)
			delete this->pAuthentication;   
		if(this->pSettings && this->pSettings != pWebSites->DfltSettings)
			delete this->pSettings;           
		if(this->pSSIFiles && this->pSSIFiles != pWebSites->DfltSSIFiles)
			delete this->pSSIFiles;
		if(this->pURLFilters && this->pURLFilters != pWebSites->DfltURLFilters)
			delete this->pURLFilters;
		if(this->pVirtualRoots && this->pVirtualRoots != pWebSites->DfltVirtualRoots)
			delete this->pVirtualRoots;
		if(this->pErrorPages && this->pErrorPages != pWebSites->DfltErrorPages)
			delete this->pErrorPages;   

		pMem->Free(this->pServer->pUserData);
		pMem->Free(this->Clients);

		delete this->pServer;

		this->CloseLog();
		DeleteCriticalSection(&this->csLogFile);
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CWebSite::Stop(void)
{
	bool bResult = true;
	if(this->pServer->IsActive())
	{
		bResult = this->pServer->Stop(true);
	}
	this->CloseLog();

	return bResult;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CWebSite::Start(void)
{
	return this->Start(this->Port);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CWebSite::Start(int iPort)
{
	bool bResult = this->CycleLog();
	if(bResult)
	{
		bResult = this->pServer->Start(this->Port);
	}
	return bResult;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::WriteLog(LOGFILEENTRY *pLFE)
{
	EnterCriticalSection(&this->csLogFile);

	char sDate[64];
	Get_ShortDate(sDate, sizeof(sDate));
	if(strcmp(sDate, this->sLogCycleDate) != 0)
	{
		if(!this->CycleLog())
		{
			return;
		}
	}

	fprintf(this->hLogFile, "%s\t%s\t%s\t%s\t%s\t%d\t%s\t"
		"%s\t%s\t%s\t%I64d\t%d\t%s\t%s\t%s\t%s\t%s\t%s\t%s\r\n",
		pLFE->sDate,pLFE->sTime,pLFE->sSiteName,pLFE->sSourceIP,
		pLFE->sHost,pLFE->iPort,pLFE->sMethod,pLFE->sURI,pLFE->sQuery,
		pLFE->sStatus,pLFE->iContentLength,pLFE->iTimeTaken,pLFE->sAgent,
		pLFE->sAccept,pLFE->sAcceptEncoding,pLFE->sAcceptLanguage,
		pLFE->sCacheControl,pLFE->sConnection,pLFE->sVersion);

	LeaveCriticalSection(&this->csLogFile);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::WriteLog(const char *sText)
{
	EnterCriticalSection(&this->csLogFile);

	char sDate[64];
	Get_ShortDate(sDate, sizeof(sDate));
	if(strcmp(sDate, this->sLogCycleDate) != 0)
	{
		if(!this->CycleLog())
		{
			return;
		}
	}

	fwrite(sText, sizeof(char), strlen(sText), this->hLogFile);
	LeaveCriticalSection(&this->csLogFile);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CWebSite::CloseLog(void)
{
	EnterCriticalSection(&this->csLogFile);
	if(this->hLogFile) fclose(this->hLogFile);
	this->hLogFile = NULL;
	LeaveCriticalSection(&this->csLogFile);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CWebSite::CycleLog(void)
{
	EnterCriticalSection(&this->csLogFile);
	bool bResult = false;

	char sTime[64];
	char sFileName[MAX_PATH];
	memset(sFileName, 0, sizeof(sFileName));

	if(Get_ShortDate(this->sLogCycleDate, sizeof(this->sLogCycleDate)) && Get_Time(sTime, sizeof(sTime), 0))
	{
		char sSiteName[MAX_PATH];

		strcpy_s(sSiteName, sizeof(sSiteName), this->Name);
		CleanFileName(sSiteName, sizeof(sSiteName));

		sprintf_s(sFileName, sizeof(sFileName), "%s\\%s",
			this->pSettings->LogPath(), sSiteName);
		CorrectReversePath(sFileName, sizeof(sFileName), true);
		if(!IsDirectory(sFileName))
		{
			if(!CreateFolderStructure(sFileName))
			{
				char sErrorMsg[2048];
				GetLastError(sErrorMsg, sizeof(sErrorMsg),
					"Site log file folder creation failed (", ")");
				strcat_s(sErrorMsg, sizeof(sErrorMsg), "\r\n\r\n\"");
				strcat_s(sErrorMsg, sizeof(sErrorMsg), sFileName);
				strcat_s(sErrorMsg, sizeof(sErrorMsg), "\"");
				((CWebSites*)this->pWebSites)->Trace(sErrorMsg);

				this->hLogFile = NULL;

				LeaveCriticalSection(&this->csLogFile);
				return false;
			}
		}

		sprintf_s(sFileName, sizeof(sFileName), "%s\\%s\\%s.txt",
			this->pSettings->LogPath(), sSiteName, this->sLogCycleDate);
		CorrectReversePath(sFileName, sizeof(sFileName), true);

		if(this->hLogFile)
		{
			fclose(this->hLogFile);
		}
 
		bResult = ((this->hLogFile = _fsopen(sFileName, "ab", _SH_DENYWR)) != NULL);
		if(bResult)
		{
			if(!this->pSettings->CacheLogFile())
			{
				setvbuf(this->hLogFile, NULL, _IONBF, 0);
			}

			char sText[1024];
			sprintf_s(sText, sizeof(sText),
				"#Software: NetworkDLS %s\r\n"
				"#Version: %s\r\n"
				"#Date: %s %s\r\n",
				gsTitleCaption, gsFileVersion, this->sLogCycleDate, sTime);
			this->WriteLog(sText);

			this->WriteLog("Date\tTime\tSite Name\tSource IP\t"
				"Host\tPort\tMethod\tURI\tQuery\tStatus\tContent Length\t"
				"Time Taken\tAgent\tAccept\tAccept Encoding\tAccept Language\t"
				"Cache Control\tConnection\tVersion\r\n");
		}
	}

	if(!bResult)
	{
		char sErrorMsg[2048];
		GetLastError(sErrorMsg, sizeof(sErrorMsg),
			"Site log file creation failed (", ")");
		strcat_s(sErrorMsg, sizeof(sErrorMsg), "\r\n\r\n\"");
		strcat_s(sErrorMsg, sizeof(sErrorMsg), sFileName);
		strcat_s(sErrorMsg, sizeof(sErrorMsg), "\"");
		((CWebSites*)this->pWebSites)->Trace(sErrorMsg);

		this->hLogFile = NULL;
	}

	LeaveCriticalSection(&this->csLogFile);
	return bResult;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CWebSite::ToXML(CXMLWriter *pXMLSite)
{
	if(pXMLSite->Initialize("Site"))
	{
		pXMLSite->Add("Name", this->Name);
		pXMLSite->Add("Description", this->Description);
		pXMLSite->Add("Root", this->Root);
		pXMLSite->Add("Port", this->Port);
		this->SubItemsToXML(pXMLSite);
		return true;
	}
	return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int CWebSite::SubItemsToXML(CXMLWriter *xmlConfig)
{
	CXMLReader xmlSub;
	int iSubItems = 0;

	if(this->pCGIFolders != ((CWebSites *)pWebSites)->DfltCGIFolders)
	{
		if(this->pCGIFolders->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pSettings != ((CWebSites *)pWebSites)->DfltSettings)
	{
		if(this->pSettings->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pMimeTypes != ((CWebSites *)pWebSites)->DfltMimeTypes)
	{
		if(this->pMimeTypes->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pExtensionFilters != ((CWebSites *)pWebSites)->DfltExtensionFilters)
	{
		if(this->pExtensionFilters->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pURLFilters != ((CWebSites *)pWebSites)->DfltURLFilters)
	{
		if(this->pURLFilters->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pDefaultPages != ((CWebSites *)pWebSites)->DfltDefaultPages)
	{
		if(this->pDefaultPages->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pVirtualRoots != ((CWebSites *)pWebSites)->DfltVirtualRoots)
	{
		if(this->pVirtualRoots->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pSSIFiles != ((CWebSites *)pWebSites)->DfltSSIFiles)
	{
		if(this->pSSIFiles->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pIPFilters != ((CWebSites *)pWebSites)->DfltIPFilters)
	{
		if(this->pIPFilters->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pCompression != ((CWebSites *)pWebSites)->DfltCompression)
	{
		if(this->pCompression->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pCustomFilters != ((CWebSites *)pWebSites)->DfltCustomFilters)
	{
		if(this->pCustomFilters->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pScriptingEngines != ((CWebSites *)pWebSites)->DfltScriptingEngines)
	{
		if(this->pScriptingEngines->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pRealms != ((CWebSites *)pWebSites)->DfltRealms)
	{
		if(this->pRealms->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pAuthentication != ((CWebSites *)pWebSites)->DfltAuthentication)
	{
		if(this->pAuthentication->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}
	if(this->pErrorPages != ((CWebSites *)pWebSites)->DfltErrorPages)
	{
		if(this->pErrorPages->ToXML(&xmlSub))
		{
			xmlConfig->Add(&xmlSub);
			xmlSub.Destroy();
			iSubItems++;
		}
	}

	return iSubItems;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CWebSite::IsActive(void)
{
	return this->pServer->IsActive();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
