///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Copyright  NetworkDLS 2002, All rights reserved
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF 
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A 
// PARTICULAR PURPOSE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifndef _HTTPFILTER_H
#define _HTTPFILTER_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define DllImport extern "C" __declspec(dllimport)
#define DllExport extern "C" __declspec(dllexport)

#define FILTER_EVENT_RESULT_OK			1
#define FILTER_EVENT_RESULT_FAIL		2

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_FILTER_LOG_ENTRY {
	char *sDate;
	char *sTime;
	char *sSiteName;
	char *sSourceIP;
	char *sMethod; //GET, PUT, POST
	char *sAgent;
	char *sStatus;
	char *sAccept;
	char *sAcceptEncoding;
	char *sAcceptLanguage;
	char *sCacheControl;
	char *sConnection;
	char *sHost;
	char *sVersion;
	unsigned int iTimeTaken; //Miliseconds.
	__int64 iContentLength; //Bytes
	char *sURI;
	char *sQuery;
	int iPort;
} FILTERLOGENTRY, *LPFILTERLOGENTRY;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_FILTER_HTTP_HEADER {
	char *Method;
	char *Request;
	char *Version;
	char *Query;
	char *ContentType;

	char *Accept;
	char *AcceptLanguage;
	char *AcceptEncoding;
	char *UserAgent;
	char *Host;
	char *Connection;
	char *CacheControl;
	char *Referer;
	char *Cookie;
	char *ContentRange;

	__int64 ContentBegin;
	__int64 ContentEnd;

	char *PostData;
	int PostDataSize;
} FILTERHTTPHEADER, *LPFILTERHTTPHEADER;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef unsigned int (*LPOnPreProcHeaders)(unsigned int iPeerID, FILTERHTTPHEADER *pHead);
typedef unsigned int (*LPOnUrlMap)(unsigned int iPeerID, const char *sURIStem, const char *sFileName);
typedef unsigned int (*LPOnSendRawData)(unsigned int iPeerID, const char *sBuf, unsigned int uiBufSz);
typedef unsigned int (*LPOnRecvRawData)(unsigned int iPeerID, const char *sBuf, unsigned int uiBufSz);
typedef unsigned int (*LPOnLog)(unsigned int iPeerID, FILTERLOGENTRY *pLFE);
typedef unsigned int (*LPOnConnect)(unsigned int iPeerID, const char *sIPAddress);
typedef unsigned int (*LPOnDisconnect)(unsigned int iPeerID);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DllExport unsigned int OnPreProcHeaders(unsigned int iPeerID, FILTERHTTPHEADER *pHead);
DllExport unsigned int OnUrlMap(unsigned int iPeerID, const char *sURIStem, const char *sFileName);
DllExport unsigned int OnSendRawData(unsigned int iPeerID, const char *sBuf, unsigned int uiBufSz);
DllExport unsigned int OnRecvRawData(unsigned int iPeerID, const char *sBuf, unsigned int uiBufSz);
DllExport unsigned int OnLog(unsigned int iPeerID, FILTERLOGENTRY *pLFE);
DllExport unsigned int OnConnect(unsigned int iPeerID, const char *sIPAddress);
DllExport unsigned int OnDisconnect(unsigned int iPeerID);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
