#ifndef _FILTER_H
#define _FILTER_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define FILTER_EVENT_ONPREPROCHEADERS	((unsigned int)0x0001)
#define FILTER_EVENT_ONAUTHENTICATION	((unsigned int)0x0002)
#define FILTER_EVENT_ONURLMAP			((unsigned int)0x0004)
#define FILTER_EVENT_ONSENDRAWDATA		((unsigned int)0x0008)
#define FILTER_EVENT_ONRECVRAWDATA		((unsigned int)0x0010)
#define FILTER_EVENT_ONLOG				((unsigned int)0x0020)
#define FILTER_EVENT_ONCONNECT			((unsigned int)0x0040)
#define FILTER_EVENT_ONDISCONNECT		((unsigned int)0x0080)

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define FILTER_EVENT_RESULT_OK			1
#define FILTER_EVENT_RESULT_FAIL		2

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_LOG_FILE_ENTRY {
	char sDate[64];
	char sTime[64];
	char *sSiteName;
	char sSourceIP[20];
	//char sTargetIP[20]; //Not yet implemented.
	char *sMethod; //GET, PUT, POST
	char *sAgent;
	char *sStatus;
	char *sAccept;
	char *sAcceptEncoding;
	char *sAcceptLanguage;
	char *sCacheControl;
	char *sConnection;
	char *sHost;
	char *sVersion;
	unsigned int iTimeTaken; //Miliseconds.
	__int64 iContentLength; //Bytes
	char *sURI;
	char *sQuery;
	int iPort;
	//char sUserName[...]; //Not yet implemented.
} LOGFILEENTRY, *LPLOGFILEENTRY;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _tag_HTTP_Header {
	char *Method;
	char *Request;
	char *Version;
	char *Query;

	char *Accept;
	char *AcceptLanguage;
	char *AcceptEncoding;
	char *UserAgent;
	char *Host;
	char *Connection;
	char *CacheControl;
	char *Referer;
	char *Cookie;
	char *ContentRange;

	char *FullRequest;

	__int64 ContentBegin;
	__int64 ContentEnd;

	char *PostData;
	int PostDataSize;
} HTTPHEADER, *LPHTTPHEADER;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
